from flask import Flask, request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,Response,jsonify,json
from core.model.NotificationModel import NotificationModel
from random import randint
from .. import Cryptography,Auth,RouteGroup,Helper,Custom
import datetime
from core.library.email import EMAIL
import math
from datetime import timedelta,date,datetime
from flask import session, app
from os import listdir
import io
import csv
import ast
import requests,mandrill,json,math
import base64
import flask
from num2words import num2words



app = Blueprint('notification', __name__)

'''--------------------------------------- Back Office Start --------------------------------------------------  '''

@app.route('/notification_index', methods = ["GET","POST"])
def NotificationIndex():
	notifiation_details = NotificationModel().get_notification_data()
	return render_template('notifications/notification_index_page.html',notifiation_details = notifiation_details)



@app.route('/notification', methods = ["GET","POST"])
def Notification():
	notifiation_details = NotificationModel().get_notification_data()
	return render_template('notifications/add_notification_page.html',notifiation_details = notifiation_details)


@app.route('/post_add_notification', methods = ["GET","POST"])
def postAddNotification():
	notification_title   = request.values.get("notification_title",None)
	notification_content = request.values.get("notification_content",None)
	now                  = datetime.now()
	data = {
			'notification_title'   : notification_title,
			'notification_content' : notification_content,
			'created_at'           : now

	}
	insert_data = NotificationModel().insert_notification_data(data)
	notifiation_details = NotificationModel().get_notification_data()
	return redirect(url_for('notification.Notification'))