from flask import request, url_for,flash, render_template,jsonify,redirect
from core import app
from flask import url_for
from datetime import datetime, date, time, timedelta
import requests,mandrill,json
from core.library.helper import Helper
from .. import Cryptography,Auth,Helper,RouteGroup

class Mandrill:	

	def sendMail(subject,html,to,mailData,conf = None):
		if conf:
			bcc_mails 		= conf['e_backup_emails']
			from_mail_name 	= conf['conf_title']
			from_mail_id 	= conf['e_from_email']
			reply_mail_id 	= conf['e_reply_to']
			if mailData:
				if mailData['bcc_mails'] is not None:
					bcc_mails = mailData['bcc_mails']	
				if mailData['from_mail_name'] is not None :
					from_mail_name = mailData['from_mail_name']
				if mailData['from_mail_id'] is not None :
					from_mail_id = mailData['from_mail_id']
				if mailData['reply_mail_id'] is not None :
					reply_mail_id = mailData['reply_mail_id']


			bcc_list = []
			if int(mailData['is_send_backup']) == 1 and int(mailData['is_send_backup'])  :
				
				if bcc_mails:
					for bcc in bcc_mails.split(","):
						bcc_list.append({'email':bcc,'name':to,'type':'to'})
						
			else:
				pass
		
			if to:
				# XEs1ytJQpEwaZSq25YgB4Q

				# 3rql7lHFpPcoHnNAWYQTFQ       --- Key 
				# MANDRILL_API_KEY='3rql7lHFpPcoHnNAWYQTFQ' # IP ADDRESS ENABLED
				MANDRILL_API_KEY = conf['secret_key']
				mandrill_client = mandrill.Mandrill(MANDRILL_API_KEY)



				message = {
					'subject'    : subject, 
					'recipients' : to,
					'from_name'  : from_mail_name,
					'html'       : html, 
					'from_email' : from_mail_id,
					"headers"    : {"Reply-To": reply_mail_id} ,
					'to'         : [{'email':to,'name':to,'type':'to'}]+bcc_list 
					}
				# print(message)
				try:
					result = mandrill_client.messages.send(message = message,send_async=True)
					if result :
						result[0]["msg_id"] = result[0]["_id"]
						result[0]["api_key"] = MANDRILL_API_KEY
						result[0]["app_type"] = "DELEGATE"
						result[0]["subject"] = subject
						data_1 = json.dumps(result[0],default=str)
						return data_1
					
				except Exception as e:
					print(str(e))
					print("error in mandrill")
				
				return ('success')
			else:
				return ('Email id is blank')
		else:
			return redirect (url_for('user.Home'))